/* This Source Code Form is subject to the terms of the Mozilla Public
 * License, v. 2.0. If a copy of the MPL was not distributed with this
 * file, You can obtain one at http://mozilla.org/MPL/2.0/. */

//! Types that can cross the FFI boundary.

pub mod callbackinterface;
pub mod ffidefault;
#[cfg(feature = "scaffolding-ffi-buffer-fns")]
pub mod ffiserialize;
pub mod foreignbytes;
pub mod foreigncallbacks;
pub mod foreignfuture;
pub mod handle;
pub mod rustbuffer;
pub mod rustcalls;
pub mod rustfuture;

pub use callbackinterface::*;
pub use ffidefault::FfiDefault;
#[cfg(feature = "scaffolding-ffi-buffer-fns")]
pub use ffiserialize::FfiSerialize;
pub use foreignbytes::*;
pub use foreigncallbacks::*;
pub use foreignfuture::*;
pub use handle::*;
pub use rustbuffer::*;
pub use rustcalls::*;
pub use rustfuture::*;
